
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>运维中搜索工具Grep, Ack, Ag的效率比较【附图】 / iVAN</title>

    <meta name="description" content="运维中搜索工具Grep, Ack, Ag的效率比较【附图】 前言 我经常看到很多程序员, 运维在代码搜索上使用ack, 甚至ag(the_silver_searcher ), 而我工作中95%都是用grep,剩下的是ag. 我觉得很有必要聊一聊这个话题. 我以前也是一个运维, 我当时也希望找到最好的最快的工具用在工作的方方面面. 但是我很好奇为什么ag和ack没有作为linux发行版的内置部分. 内置的一直是grep. 我当初的理解是受各种开源协议的限制, 或者发行版的boss个人喜好. 后来我就做了实验, 研究了下他们到底谁快. 当时的做法也无非跑几个">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">运维中搜索工具Grep, Ack, Ag的效率比较【附图】</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>前言</strong></p>
<p>我经常看到很多程序员, 运维在代码搜索上使用ack, 甚至ag(the_silver_searcher ), 而我工作中95%都是用grep,剩下的是ag. 我觉得很有必要聊一聊这个话题. 我以前也是一个运维, 我当时也希望找到最好的最快的工具用在工作的方方面面. 但是我很好奇为什么ag和ack没有作为linux发行版的内置部分. 内置的一直是grep. 我当初的理解是受各种开源协议的限制, 或者发行版的boss个人喜好. 后来我就做了实验, 研究了下他们到底谁快. 当时的做法也无非跑几个真实地线上log看看用时. 然后我也有了我的一个认识: 大部分时候用grep也无妨, 日志很大的时候用ag.</p>
<p>ack原来的域名是betterthangrep.com, 现在是beyondgrep.com. 好吧. 其实我理解使用ack的同学, 也理解ack产生的原因. 这里就有个故事.</p>
<p>最开始我做运维使用shell, 经常做一些分析日志的工作. 那时候经常写比较复杂的shell代码实现一些特定的需求. 后来来了一位会perl的同学. 原来我写shell做一个事情, 写了20多行shell代码, 跑一次大概5分钟, 这位同学来了用perl改写, 4行, 一分钟就能跑完. 亮瞎我们的眼, 从那时候开始, 我就觉得需要学perl,以至于后来的python.</p>
<p>perl是天生用来文本解析的语言, ack的效率确实很高. 我想着可能是大家认为ack要更快更合适的理由吧. 其实这件事要看场景. 我为什么还用比较’土’的grep呢? 看一下这篇文章, 希望给大家点启示</p>
<p><strong>实验条件</strong></p>
<p>PS: 严重声明, 本实验经个人实践, 我尽量做到合理. 大家看完觉得有异议可以试着其他的角度来做. 并和我讨论.</p>
<p>    我使用了公司的一台开发机(gentoo)</p>
<p>    我测试了纯英文和汉语2种， 汉语使用了结巴分词的字典, 英语使用了miscfiles中提供的词典</p>
<p># 假如你是ubuntu: sudo apt-get install miscfiles<br />wget https://raw.githubusercontent.com/fxsjy/jieba/master/extra_dict/dict.txt.big</p>
<p><strong>实验前的准备</strong></p>
<p>我会分成英语和汉语2种文件, 文件大小为1MB, 10MB, 100MB, 500MB, 1GB, 5GB. 没有更多是我觉得在实际业务里面不会单个日志文件过大的. 也就没有必要测试了(就算有, 可以看下面结果的趋势)</p>
<p>cat make_words.py<br /># coding=utf-8</p>
<p>import os<br />import random<br />from cStringIO import StringIO</p>
<p>EN_WORD_FILE = '/usr/share/dict/words'<br />CN_WORD_FILE = 'dict.txt.big'<br />with open(EN_WORD_FILE) as f:<br />    EN_DATA = f.readlines()<br />with open(CN_WORD_FILE) as f:<br />    CN_DATA = f.readlines()<br />MB = pow(1024, 2)<br />SIZE_LIST = [1, 10, 100, 500, 1024, 1024 * 5]<br />EN_RESULT_FORMAT = 'text_{0}_en_MB.txt'<br />CN_RESULT_FORMAT = 'text_{0}_cn_MB.txt'</p>
<p>def write_data(f, size, data, cn=False):<br />    total_size = 0<br />    while 1:<br />        s = StringIO()<br />        for x in range(10000):<br />            cho = random.choice(data)<br />            cho = cho.split()[0] if cn else cho.strip()<br />            s.write(cho)<br />        s.seek(0, os.SEEK_END)<br />        total_size += s.tell()<br />        contents = s.getvalue()<br />        f.write(contents + '\n')<br />        if total_size &gt; size:<br />            break<br />    f.close()</p>
<p>for index, size in enumerate([<br />        MB,<br />        MB * 10,<br />        MB * 100,<br />        MB * 500,<br />        MB * 1024,<br />        MB * 1024 * 5]):<br />    size_name = SIZE_LIST[index]<br />    en_f = open(EN_RESULT_FORMAT.format(size_name), 'a+')<br />    cn_f = open(CN_RESULT_FORMAT.format(size_name), 'a+')<br />    write_data(en_f, size, EN_DATA)<br />    write_data(cn_f, size, CN_DATA, True)</p>
<p>好吧, 效率比较低是吧? 我自己没有vps, 公司服务器我不能没事把全部内核的cpu都占满(不是运维好几年了). 假如你不介意htop的多核cpu飘红, 可以这样，耗时就是各文件生成的时间短板:</p>
<p> # coding=utf-8</p>
<p>import os<br />import random<br />import multiprocessing<br />from cStringIO import StringIO</p>
<p>EN_WORD_FILE = '/usr/share/dict/words'<br />CN_WORD_FILE = 'dict.txt.big'<br />with open(EN_WORD_FILE) as f:<br />    EN_DATA = f.readlines()<br />with open(CN_WORD_FILE) as f:<br />    CN_DATA = f.readlines()<br />MB = pow(1024, 2)<br />SIZE_LIST = [1, 10, 100, 500, 1024, 1024 * 5]<br />EN_RESULT_FORMAT = 'text_{0}_en_MB.txt'<br />CN_RESULT_FORMAT = 'text_{0}_cn_MB.txt'</p>
<p>inputs = []</p>
<p>def map_func(args):<br />    def write_data(f, size, data, cn=False):<br />        f = open(f, 'a+')<br />        total_size = 0<br />        while 1:<br />            s = StringIO()<br />            for x in range(10000):<br />                cho = random.choice(data)<br />                cho = cho.split()[0] if cn else cho.strip()<br />                s.write(cho)<br />            s.seek(0, os.SEEK_END)<br />            total_size += s.tell()<br />            contents = s.getvalue()<br />            f.write(contents + '\n')<br />            if total_size &gt; size:<br />                break<br />        f.close()</p>
<p>    _f, size, data, cn = args<br />    write_data(_f, size, data, cn)</p>
<p>for index, size in enumerate([<br />        MB,<br />        MB * 10,<br />        MB * 100,<br />        MB * 500,<br />        MB * 1024,<br />        MB * 1024 * 5]):<br />    size_name = SIZE_LIST[index]<br />    inputs.append((EN_RESULT_FORMAT.format(size_name), size, EN_DATA, False))<br />    inputs.append((CN_RESULT_FORMAT.format(size_name), size, CN_DATA, True))</p>
<p>pool = multiprocessing.Pool()<br />pool.map(map_func, inputs, chunksize=1)</p>
<p>等待一段时间后,目录下是这样的:</p>
<p>$ls -lh<br />total 14G<br />-rw-rw-r-- 1 vagrant vagrant 2.2K Mar 14 05:25 benchmarks.ipynb<br />-rw-rw-r-- 1 vagrant vagrant 8.2M Mar 12 15:43 dict.txt.big<br />-rw-rw-r-- 1 vagrant vagrant 1.2K Mar 12 15:46 make_words.py<br />-rw-rw-r-- 1 vagrant vagrant 101M Mar 12 15:47 text_100_cn_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 101M Mar 12 15:47 text_100_en_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 1.1G Mar 12 15:54 text_1024_cn_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 1.1G Mar 12 15:51 text_1024_en_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant  11M Mar 12 15:47 text_10_cn_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant  11M Mar 12 15:47 text_10_en_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 1.1M Mar 12 15:47 text_1_cn_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 1.1M Mar 12 15:47 text_1_en_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 501M Mar 12 15:49 text_500_cn_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 501M Mar 12 15:48 text_500_en_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 5.1G Mar 12 16:16 text_5120_cn_MB.txt<br />-rw-rw-r-- 1 vagrant vagrant 5.1G Mar 12 16:04 text_5120_en_MB.txt</p>
<p><strong>确认版本</strong></p>
<p>➜  test  ack --version # ack在ubuntu下叫`ack-grep`<br />ack 2.12<br />Running under Perl 5.16.3 at /usr/bin/perl</p>
<p>Copyright 2005-2013 Andy Lester.</p>
<p>This program is free software.  You may modify or distribute it<br />under the terms of the Artistic License v2.0.<br />➜  test  ag --version<br />ag version 0.21.0<br />➜  test  grep --version<br />grep (GNU grep) 2.14<br />Copyright (C) 2012 Free Software Foundation, Inc.<br />License GPLv3+: GNU GPL version 3 or later &lt;http://gnu.org/licenses/gpl.html&gt;.<br />This is free software: you are free to change and redistribute it.<br />There is NO WARRANTY, to the extent permitted by law.</p>
<p>Written by Mike Haertel and others, see &lt;http://git.sv.gnu.org/cgit/grep.git/tree/AUTHORS&gt;.</p>
<p>实验设计</p>
<p>为了不产生并行执行的相互响应, 我还是选择了效率很差的同步执行, 我使用了ipython提供的%timeit. 上代码</p>
<p>import re<br />import glob<br />import subprocess<br />import cPickle as pickle<br />from collections import defaultdict</p>
<p>IMAP = {<br />    'cn': ('豆瓣', '小明明'),<br />    'en': ('four', 'python')<br />}<br />OPTIONS = ('', '-i', '-v')<br />FILES = glob.glob('text_*_MB.txt')<br />EN_RES = defaultdict(dict)<br />CN_RES = defaultdict(dict)<br />RES = {<br />        'en': EN_RES,<br />        'cn': CN_RES<br />}<br />REGEX = re.compile(r'text_(\d+)_(\w+)_MB.txt')<br />CALL_STR = '{command} {option} {word} {filename} &gt; /dev/null 2&gt;&amp;1'</p>
<p>for filename in FILES:<br />    size, xn = REGEX.search(filename).groups()<br />    for word in IMAP[xn]:<br />        _r = defaultdict(dict)<br />        for command in ['grep', 'ack', 'ag']:<br />            for option in OPTIONS:<br />                rs = %timeit -o -n10 subprocess.call(CALL_STR.format(command=command, option=option, word=word, filename=filename), shell=True)<br />                best = rs.best<br />                _r[command][option] = best<br />        RES[xn][word][size] = _r</p>
<p># 存起来</p>
<p>data = pickle.dumps(RES)</p>
<p>with open('result.db', 'w') as f:<br />    f.write(data)</p>
<p>温馨提示, 这是一个灰常耗时的测试. 开始执行后 要喝很久的茶…</p>
<p>我来秦皇岛办事完毕(耗时超过1一天), 继续我们的实验.</p>
<p><strong>我想要的效果</strong></p>
<p>我想工作的时候一般都是用到不带参数/带-i(忽略大小写)/-v(查找不匹配项)这三种. 所以这里测试了:</p>
<p>    英文搜索/中文搜索<br />    选择了2个搜索词(效率太低, 否则可能选择多个)<br />    分别测试’’/’-i’/’-v’三种参数的执行<br />    使用%timeit, 每种条件执行10遍, 选择效率最好的一次的结果<br />    每个图代码一个搜索词, 3搜索命令, 一个选项在搜索不同大小文件时的效率对比</p>
<p>多图预警, 我先说结论</p>
<p>    在搜索的总数据量较小的情况下, 使用grep, ack甚至ag在感官上区别不大<br />    搜索的总数据量较大时, grep效率下滑的很多, 完全不要选<br />    ack在某些场景下没有grep效果高(比如使用-v索索中文的时候)<br />    在不使用ag没有实现的选项功能的前提下, ag完全可以替代ack/grep</p>
<p>渲染图片的gist可以看这里benchmarks.ipynb. 他的数据来自上面跑的结果在序列化之后存入的文件</p>
<p><strong>附图</strong></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzI2ZDdiMC1jYmNiLTExZTQtOGYyYS1jZmE1ZmUyN2M4MTAucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzJjMTJhYy1jYmNiLTExZTQtOTI5NS1jZmRkNmQ0MjE0MjMucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzJjMzAzNC1jYmNiLTExZTQtOWEyYy01NjA0YmYyYmIwYzYucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzJkZjRhMC1jYmNiLTExZTQtOGQ3NS01MzhhZDUyN2NiNGYucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzMzNzJkNi1jYmNiLTExZTQtOGI5Ni01NGFlOWFlNjhmNTcucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzM1YzA0YS1jYmNiLTExZTQtODQwMS0wYzU0YWE0ZWI3ODMucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzYyYmY5Ni1jYmNiLTExZTQtOWVjNS05NDY4NmU2MDNlM2EucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS80ODhlOWFmNC1jY2ZhLTExZTQtOGExZi0xZmEzNjY3ZGQ3NGYucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzZiMzA3Yy1jYmNiLTExZTQtOTQyZC04YTM5NWEyODk4NGYucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS84MzZmNGY1ZS1jYmNiLTExZTQtODgwNy1kNmY1NjEwMTgyNTQucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS9mYmQ0MmNlZS1jYmNiLTExZTQtOWMxZC1iMjIzNzE5NGRiOTAucG5n.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS9mYzU0MjRmOC1jYmNiLTExZTQtOWJmMC0xNjY2Y2Q0NjcyMzkucG5n.jpg"></p>
<p><strong>The silver search(ag)比ack-grep还快</strong></p>
<p>今天用ag搜索android4.1的代码，发现总是被一个长得让崩溃的.json文件匹配(键入ag ::layout)搞得没法健康地查看ag.el的结果。</p>
<p>一看ag的代码才知道这长行打印压制还是个未完成功能</p>
<p>src/options.h:48:30:    int print_long_lines; /* TODO: support this in print.c */</p>
<p>好在作者的C代码简洁明了，使得我可以很快写出一个Patch，使用-M 参数来压制长行输出。patch邮件已经发送。我自己也backup一下：</p>
<p>diff --git a/src/options.c b/src/options.c  <br />index b08903f..2f4b18e 100644  <br />--- a/src/options.c  <br />+++ b/src/options.c  <br />@@ -77,6 +77,8 @@ Search options:\n\  <br /> -p --path-to-agignore STRING\n\  <br />                         Use .agignore file at STRING\n\  <br /> --print-long-lines      Print matches on very long lines (Default: &gt;2k characters)\n\  <br />+-M --max-printable-line-length NUM \n\  <br />+                        Skip print the matching lines that have a length bigger than NUM\n      \  <br /> -Q --literal            Don't parse PATTERN as a regular expression\n\  <br /> -s --case-sensitive     Match case sensitively (Enabled by default)\n\  <br /> -S --smart-case         Match case insensitively unless PATTERN contains\n\  <br />@@ -115,6 +117,7 @@ void init_options() {  <br />     opts.color_path = ag_strdup(color_path);  <br />     opts.color_match = ag_strdup(color_match);  <br />     opts.color_line_number = ag_strdup(color_line_number);  <br />+    opts.max_printable_line_length = DEFAULT_MAX_PRINTABLE_LINE_LENGTH;  <br /> }  <br />   <br /> void cleanup_options() {  <br />@@ -221,6 +224,7 @@ void parse_options(int argc, char **argv, char **base_paths[], char **paths[]) {  <br />         { "version", no_argument, &amp;version, 1 },  <br />         { "word-regexp", no_argument, NULL, 'w' },  <br />         { "workers", required_argument, NULL, 0 },  <br />+        { "max-printable-line-length", required_argument, NULL, 'M' },  <br />         { NULL, 0, NULL, 0 }  <br />     };  <br />   <br />@@ -253,7 +257,7 @@ void parse_options(int argc, char **argv, char **base_paths[], char **paths[]) {  <br />         opts.stdout_inode = statbuf.st_ino;  <br />     }  <br />   <br />-    while ((ch = getopt_long(argc, argv, "A:aB:C:DG:g:fhiLlm:np:QRrSsvVtuUwz", longopts, &amp;opt_index)) != -1) {  <br />+    while ((ch = getopt_long(argc, argv, "A:aB:C:DG:g:fhiLlm:M:np:QRrSsvVtuUwz", longopts, &amp;opt_index)) != -1) {  <br />         switch (ch) {  <br />             case 'A':  <br />                 opts.after = atoi(optarg);  <br />@@ -305,6 +309,9 @@ void parse_options(int argc, char **argv, char **base_paths[], char **paths[]) {  <br />             case 'm':  <br />                 opts.max_matches_per_file = atoi(optarg);  <br />                 break;  <br />+            case 'M':  <br />+                opts.max_printable_line_length = atoi(optarg);  <br />+                break;  <br />             case 'n':  <br />                 opts.recurse_dirs = 0;  <br />                 break;  <br />diff --git a/src/options.h b/src/options.h  <br />index 5049ab5..b4d2468 100644  <br />--- a/src/options.h  <br />+++ b/src/options.h  <br />@@ -7,6 +7,7 @@  <br /> #include &lt;pcre.h&gt;  <br />   <br /> #define DEFAULT_CONTEXT_LEN 2  <br />+#define DEFAULT_MAX_PRINTABLE_LINE_LENGTH 2000  <br />   <br /> enum case_behavior {  <br />     CASE_SENSITIVE,  <br />@@ -45,6 +46,7 @@ typedef struct {  <br />     int print_heading;  <br />     int print_line_numbers;  <br />     int print_long_lines; /* TODO: support this in print.c */  <br />+    int max_printable_line_length;  <br />     pcre *re;  <br />     pcre_extra *re_extra;  <br />     int recurse_dirs;  <br />diff --git a/src/print.c b/src/print.c  <br />index dc11594..4be9874 100644  <br />--- a/src/print.c  <br />+++ b/src/print.c  <br />@@ -34,6 +34,15 @@ void print_binary_file_matches(const char* path) {  <br />     fprintf(out_fd, "Binary file %s matches.\n", path);  <br /> }  <br />   <br />+static void check_printable(int len, int *printable) {  <br />+    if (len &gt; opts.max_printable_line_length) {  <br />+        *printable = FALSE;  <br />+        fprintf(out_fd, "+EVIL+MARK+VERY+LONG+LINES+HERE\n");  <br />+    } else {  <br />+        *printable = TRUE;  <br />+    }  <br />+}  <br />+  <br /> void print_file_matches(const char* path, const char* buf, const int buf_len, const match matches[], const int matches_len) {  <br />     int line = 1;  <br />     char **context_prev_lines = NULL;  <br />@@ -49,6 +58,7 @@ void print_file_matches(const char* path, const char* buf, const int buf_len, co  <br />     int i, j;  <br />     int in_a_match = FALSE;  <br />     int printing_a_match = FALSE;  <br />+    int printable = TRUE;  <br />   <br />     if (opts.ackmate) {  <br />         sep = ':';  <br />@@ -129,7 +139,8 @@ void print_file_matches(const char* path, const char* buf, const int buf_len, co  <br />                     }  <br />                     j = prev_line_offset;  <br />                     /* print up to current char */  <br />-                    for (; j &lt;= i; j++) {  <br />+                    check_printable(i - prev_line_offset, &amp;printable);  <br />+                    for (; j &lt;= i &amp;&amp; printable; j++) {  <br />                         fputc(buf[j], out_fd);  <br />                     }  <br />                 } else {  <br />@@ -141,7 +152,8 @@ void print_file_matches(const char* path, const char* buf, const int buf_len, co  <br />                     if (printing_a_match &amp;&amp; opts.color) {  <br />                         fprintf(out_fd, "%s", opts.color_match);  <br />                     }  <br />-                    for (j = prev_line_offset; j &lt;= i; j++) {  <br />+                    check_printable(i - prev_line_offset, &amp;printable);  <br />+                    for (j = prev_line_offset; j &lt;= i &amp;&amp; printable; j++) {  <br />                         if (j == matches[last_printed_match].end &amp;&amp; last_printed_match &lt; matches_len) {  <br />                             if (opts.color) {  <br />                                 fprintf(out_fd, "%s", color_reset);  </p>
<p><strong>在文件中搜索文本工具grep命令用法</strong></p>
<p>grep（global search regular expression(RE) and print out the line，全面搜索正则表达式并把行打印出来）是一种强大的文本搜索工具，它能使用正则表达式搜索文本，并把匹配的行打印出来。</p>
<p>grep命令选项<br />-a 不要忽略二进制数据。<br />-A &lt;显示列数&gt; 除了显示符合范本样式的那一行之外，并显示该行之后的内容。<br />-b 在显示符合范本样式的那一行之外，并显示该行之前的内容。<br />-c 计算符合范本样式的列数。<br />-C &lt;显示列数&gt;或-&lt;显示列数&gt; 除了显示符合范本样式的那一列之外，并显示该列之前后的内容。<br />-d &lt;进行动作&gt; 当指定要查找的是目录而非文件时，必须使用这项参数，否则grep命令将回报信息并停止动作。<br />-e &lt;范本样式&gt; 指定字符串作为查找文件内容的范本样式。<br />-E 将范本样式为延伸的普通表示法来使用，意味着使用能使用扩展正则表达式。<br />-f &lt;范本文件&gt; 指定范本文件，其内容有一个或多个范本样式，让grep查找符合范本条件的文件内容，格式为每一列的范本样式。<br />-F 将范本样式视为固定字符串的列表。<br />-G 将范本样式视为普通的表示法来使用。<br />-h 在显示符合范本样式的那一列之前，不标示该列所属的文件名称。<br />-H 在显示符合范本样式的那一列之前，标示该列的文件名称。<br />-i 胡列字符大小写的差别。<br />-l 列出文件内容符合指定的范本样式的文件名称。<br />-L 列出文件内容不符合指定的范本样式的文件名称。<br />-n 在显示符合范本样式的那一列之前，标示出该列的编号。<br />-q 不显示任何信息。<br />-R /-r 此参数的效果和指定“-d recurse”参数相同。<br />-s  不显示错误信息。<br />-v 反转查找。<br />-w 只显示全字符合的列。<br />-x 只显示全列符合的列。<br />-y 此参数效果跟“-i”相同。<br />-o 只输出文件中匹配到的部分。</p>
<p>grep命令常见用法<br />在文件中搜索一个单词，命令会返回一个包含“match_pattern”的文本行：<br /># grep match_pattern file_name<br /># grep "match_pattern" file_name</p>
<p>在多个文件中查找：<br /># grep "match_pattern" file_1 file_2 file_3 ...</p>
<p>输出除之外的所有行 -v 选项：<br /># grep -v "match_pattern" file_name</p>
<p>标记匹配颜色 ?color=auto 选项：<br /># grep "match_pattern" file_name --color=auto</p>
<p>使用正则表达式 -E 选项：<br /># grep -E "[1-9]+"<br />或<br /># egrep "[1-9]+"</p>
<p>只输出文件中匹配到的部分 -o 选项：<br /># echo this is a test line. | grep -o -E "[a-z]+\."<br />line.<br /># echo this is a test line. | egrep -o "[a-z]+\."<br />line.</p>
<p>统计文件或者文本中包含匹配字符串的行数 -c 选项：<br /># grep -c "text" file_name</p>
<p>输出包含匹配字符串的行数 -n 选项：<br /># grep "text" -n file_name<br />或<br /># cat file_name | grep "text" -n<br />#多个文件<br /># grep "text" -n file_1 file_2</p>
<p>打印样式匹配所位于的字符或字节偏移：<br /># echo gun is not unix | grep -b -o "not"<br />7:not<br />#一行中字符串的字符便宜是从该行的第一个字符开始计算，起始值为0。选项 -b -o 一般总是配合使用。</p>
<p>搜索多个文件并查找匹配文本在哪些文件中：<br /># grep -l "text" file1 file2 file3...</p>
<p>grep递归搜索文件<br />在多级目录中对文本进行递归搜索：<br /># grep "text" . -r -n<br /># .表示当前目录。</p>
<p>忽略匹配样式中的字符大小写：<br /># echo "hello world" | grep -i "HELLO"<br />hello</p>
<p>选项 -e 制动多个匹配样式：<br /># echo this is a text line | grep -e "is" -e "line" -o<br />is<br />line<br />#也可以使用-f选项来匹配多个样式，在样式文件中逐行写出需要匹配的字符。<br /># cat patfile<br />aaa<br />bbb<br /># echo aaa bbb ccc ddd eee | grep -f patfile -o</p>
<p>在grep搜索结果中包括或者排除指定文件：<br />#只在目录中所有的.php和.html文件中递归搜索字符"main()"<br /># grep "main()" . -r --include *.{php,html}<br />#在搜索结果中排除所有README文件<br /># grep "main()" . -r --exclude "README"<br />#在搜索结果中排除filelist文件列表里的文件<br /># grep "main()" . -r --exclude-from filelist</p>
<p>使用0值字节后缀的grep与xargs：<br />#测试文件：<br /># echo "aaa" &gt; file1<br /># echo "bbb" &gt; file2<br /># echo "aaa" &gt; file3<br /># grep "aaa" file* -lZ | xargs -0 rm<br />#执行后会删除file1和file3，grep输出用-Z选项来指定以0值字节作为终结符文件名（\0），xargs -0 读取输入并用0值字节终结符分隔文件名，然后删除匹配文件，-Z通常和-l结合使用。</p>
<p>grep静默输出：<br /># grep -q "test" filename<br />#不会输出任何信息，如果命令运行成功返回0，失败则返回非0值。一般用于条件测试。</p>
<p>打印出匹配文本之前或者之后的行：<br />#显示匹配某个结果之后的3行，使用 -A 选项：<br /># seq 10 | grep "5" -A 3<br />5<br />6<br />7<br />8<br /> <br />#显示匹配某个结果之前的3行，使用 -B 选项：<br /># seq 10 | grep "5" -B 3<br />2<br />3<br />4<br />5<br /> <br />#显示匹配某个结果的前三行和后三行，使用 -C 选项：<br /># seq 10 | grep "5" -C 3<br />2<br />3<br />4<br />5<br />6<br />7<br />8<br /> <br />#如果匹配结果有多个，会用“--”作为各匹配结果之间的分隔符：<br /># echo -e "a\nb\nc\na\nb\nc" | grep a -A 1<br />a<br />b<br />--<br />a<br />b</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-30 15:05:29</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>, <a href="https://www.iamivan.net/tag/%e6%90%9c%e7%b4%a2/" title="搜索">搜索</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.iamivan.net/tag/int/" title="int">int</a>, <a href="https://www.iamivan.net/tag/%e6%95%88%e7%8e%87/" title="效率">效率</a>, <a href="https://www.iamivan.net/tag/const/" title="const">const</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>运维中搜索工具Grep, Ack, Ag的效率比较【附图】的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWokEz.html" rel="bookmark">何不 Ack？Grep&comma; Ack&comma; Ag的搜索效率对比</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				何不 Ack?Grep, Ack, Ag的搜索效率对比 前言 我(@董伟明9 )经常看到很多程序员, 运维在代码搜索上使用ack, 甚至ag(the_silver_searcher ), 而我工作中95%都是用grep,剩下的是ag. 我觉得很有必要聊一聊这个话题. 我以前也是一个运维, 我当时也希望找到最好的最快的工具用在工作的方方面面. 但是我很好奇为什么ag和ack没有作为linux发行版的内置部分. 内置的一直是grep. 我当初的理解是受各种开源协议的限制, 或者发行版的boss个人喜			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKY1JEp.html" rel="bookmark">威胁情报在甲方安全运维中的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 很多企业使用 SIEM 来收集日志数据,并将安全事件与多类安全设备(入侵检测设备.Web应用防火墙等)日志相关联,指导安全人员进行风险处置.然而 SIEM 也存在局限,监控人员往往被淹没在海量的告警之中无从下手,原因之一就是对于威胁的告警没有处理的依据,例如缺乏经验的监控人员很难判定一条安全事件告警是扫描还是针对性攻击引起的(通常后者需要更多关注).而通过借助于威胁情报,可为监控人员提供处理依据,也可为安全人员在进行日志分析和攻击溯源时提供有力帮助. 在本文中,来自证通股份有限公司的安全管			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0RN68z.html" rel="bookmark">DBA避坑宝典：Oracle运维中的那些事儿</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对于Oracle运维中的那些事儿,我的最终目的:不是比谁更惨,而是能够从中吸取经验和教训. 从我的理解来看,我会从下面的几个方面来进行说明DBA运维中的一些事儿. 每个部分都是非常关键的,缺一不可,而且每一部分都有很多的东西可以细化,我会逐一展开来说. (一)环境篇   首先来说说环境篇. DBA的角色及分工 对于DBA的分工,以前的公司对于DBA角色划分粒度还是很细的. 大体是按照核心和客户化定制层来划分的,核心层主要负责产品化,客户化层面主要负责定制.属于不同的产品线但又彼此紧密关联. Ph			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4egeqb.html" rel="bookmark">搜狐畅游高级DBA：Oracle运维中的实战经验和应对技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作为一个孜孜不倦.已连续坚持技术写作800多天的技术分享人,搜狐畅游资深数据库专家杨建荣在Gdevops全球敏捷运维峰会北京站的讲台,给现场带来了一场题为&lt;Oracle运维中的些实战经验和应对技巧&gt;的深度分享.他匠心独运,见微知著,先从国内外食品安全事件讲起,再在反思诱因的过程中类比到运维问题,进而引申出对体系.预防.规矩和工具四大问题的探讨.   (点击&quot;这里&quot;听杨建荣演讲完整录音)   古有云:&quot;欲事之无繁,则必劳于始而逸于终&quot;,如果想要整个运维体系			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balBAgz.html" rel="bookmark">Exchange Server 2010学习（十七）运维中的故障诊断小工具的使用简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Exchange项目经过规划.部署.测试之后进入运维环节,管理员需要掌握日常维护.监视和队列跟踪基本管理工作.简单来说,维护的目的是为了保证邮件系统的正常工作以及数据出现故障时的及时恢复:监视的目的是砍服务和进程的正常运作:跟踪Exchange服务器队列是为了保证邮件处于正常的处理流程中.本文章主要是介绍故障诊断的基本知识. 管理员可以借助Exchange管理控制台工具笨中的邮件流疑难解答程序和性能疑难解答程序来解决邮件的相关故障.邮件流疑难解答程序主要用于诊断邮件流的问题,诸如邮件传递延迟问题			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK0gBOM.html" rel="bookmark">命令行接口（CLI）将被取而代之，它不再是网络运维的主要工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Gartner声称:到2020年,CLI的使用将日渐式微. 多年来,网络工程师依赖命令行接口:据市场研究公司Gartner的分析师们声称,但是这种使用很普遍的工具正在迅速让位于配置和运维网络的其他方法.实际上,他们预测,到2020年,只有30%的网络运维团队会使用CLI作为主要界面,这比今天的85%大幅下降. 预测CLI的角色日渐式微是Gartner最近发布的众多企业网络预测之一. 据Gartner声称,CLI沦为小角色是由于企业需要通过实现运维任务自动化,加大网络灵活性,以便支持数字化企业.企			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6qQPYb.html" rel="bookmark">ITIL在数据中心运维中的应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着数据中心建设规模越来越大,运维的工作变得十分重要.运维的工作效率与好坏在一定程度上决定了数据中心的整体水平.数据中心运维工作涉及两大方面:一是确保数据中心的稳定性而对数据中心各个环节进行维护;二是当数据中心内出现问题时,能够及时定位并且解决,以缩短故障时间.前一个是基础,后一个是关键.这就像当兵打仗,俗话说&quot;养兵千日,用在一时&quot;,平时对数据中心各个方面进行了精心的检查和熟悉,对整个数据中心状况了如指掌,那在数据中心发生故障时,才能迅速找到痛点,明确故障原因,并采取恢复措施.一个数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6ZeDgM.html" rel="bookmark">搜狐畅游高级DBA：Data Guard运维中的实战经验和技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本次分享由以下几个部分组成: Data Guard的灾备介绍 备库的设计方案考虑 备库敏感的几个数据文件类操作 对Switchover和Failover的建议 SQL审核之Snapshot Standby Data Guard搭建/重建的小技巧   写在前面 之前有一个朋友很有深意的问我Data Guard和RAC哪个更重要,前提是在高可用和容灾两者之间来选择,只能选其一,我是毫不犹豫选择Data Guard,毕竟这是数据安全的基本防线,我想Data Guard的命名(中文翻译为数据卫士)也是这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxojDRb.html" rel="bookmark">《DevOps实战：VMware管理员运维方法、工具及最佳实践》&mdash;&mdash;3&period;4　管理源代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.4 管理源代码 源代码管理(SCM,Source Code Management)是DevOps环境中必不可少的元素.想象一下:如果你要把基础设施转换为代码,重要的是有一种回顾任何更改.在新更改引入问题(例如,在最好的情况下是定期出现不稳定的情况,在最糟糕的情况下引起停机)时回到文件不同版本的手段.有些人可能认为&quot;容易&quot;的方法是建立文件的多个拷贝,每个都使用唯一的名称(Vagrantf?ile1.Vagrantf?ile2.Vagrantf?ile01012015等),但是接着当你			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvJnAM.html" rel="bookmark" class="title">微信推送模板消息的PHP代码整理</a>
					<div>
						最近做过一个需要推送消息的系统,就研究了一下微信的模板消息的推送.由于认证过的微信号,就用测试号做的,但是过程基本一致. 本文基于微信平台的官方文档写成,http://mp.weixin.qq.com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVZYnz.html" rel="bookmark" class="title">Fireworks制作变色banner</a>
					<div>
						Fireworks不仅在网页制图.切图.与Dreamweaver结合上有其独到的优势,制作GIF动画也是它的强项,本文我们一起学习如何使用Fireworks MX制作一个平滑变色效果的Banner,相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYG4Qz.html" rel="bookmark" class="title">java程序员&colon;开发系统要注意的基本知识</a>
					<div>
						程序|程序员 问题一:我声明了什么! String s = &quot;Hello world!&quot;; 许多人都做过这样的事情,但是,我们到底声明了什么?回答通常是:一个String,内容是& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeyexz.html" rel="bookmark" class="title">网络新闻不能猛盯&OpenCurlyDoubleQuote;下三路&rdquo;</a>
					<div>
						网络 越来越多的人已经离不开网络,与此相适应的是网络新闻的兴起.网络新闻一个是快,及时迅捷:一个是全,针对某一事件,可以综合电视.报纸.杂志等媒体的说法,从多个角度关照一个新闻事件.正因为网络新闻具备 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw3g5z.html" rel="bookmark" class="title">如何在SQL Server中保存和输出图片</a>
					<div>
						server 建表 为了试验这个例子你需要一个含有数据的table(你可以在现在的库中创建它,也可以创建一个新的数据库),下面是它的结构: Column Name Datatype Purpose I ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNPk0b.html" rel="bookmark" class="title">HBA及WWN概述</a>
					<div>
						1.首先介绍一下什么是HBA. 这里所说的HBA,全称FC HBA,也就是Fibre Channel Host Bus Adapter.在FC网络中,主机(如服务器)需要和FC网络.FC存储设备(如S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2Xrob.html" rel="bookmark" class="title">WCF技术剖析之三：如何进行基于非HTTP的IIS服务寄宿</a>
					<div>
						在上面一篇文章中,我们对不同版本的IIS,以及ASP.NET得的实现机制进行了详细而深入的分析.在介绍IIS7.0的时候,我们谈到,HTTP.SYS+W3SVC实现了基于HTTP的请求监听,在此基础上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6eV6z.html" rel="bookmark" class="title">用PS人像美容</a>
					<div>
						  用photoshop/ target=_blank class=infotextkey&gt;ps人像美容           原图 最终效果 1.把原图素材大图保存到本机,然后用PS打开;创建黑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3N160z.html" rel="bookmark" class="title">PS蒙板制作趣味花艺文字</a>
					<div>
						  一.找一丛你喜欢的花 STEP 01 要寻找主角并不那么容易,如果你自己刚好手边有一束花就再好不过了,但如果没有,你需要在万千图库中淘一淘.因为要嵌入文字,因此你最好找那种容易被嵌入的,背景为白色 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrG5lp.html" rel="bookmark" class="title">Photoshop给木篱边的人物加上高对比暗调霞光</a>
					<div>
						  Photoshop给木篱边的人物加上高对比暗调霞光.素材图片整体比较亮,处理之前,我们需要把图片暗部大幅压暗,营造一种的暗的氛围;然后给天空部分换上较暗的霞光;后期微调人物颜色,局部增加一些高光即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjWwEp.html" rel="bookmark" class="title">Flash制作闪闪发光动画教程</a>
					<div>
						          你会说,随便导入就可以了啊,可是那是针对一些桢数很少的动态图导入的,你可以手动移动它们的位置,可假如你要导入的动态图有几十桢你该怎么办呢?而且默认的UA5的动态图一直放在左上角,要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPGg0z.html" rel="bookmark" class="title">谷歌浏览器键盘快捷键大全</a>
					<div>
						窗口和标签页快捷方式 Ctrl+N 打开新窗口 按住 Ctrl‎ 键,然后点击链接 在新标签页中打开链接 按住 Shift 键,然后点击链接 在新窗口中打开链接 Alt+F4 关闭当前窗口 Ctrl+ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2Evab.html" rel="bookmark" class="title">如何在word中设置不连续的页码？</a>
					<div>
						有些word封面不需要页码,目录需要一个从第一页开始的页码,正文需要一个从第一页开始的页码.如果在页眉页脚插入页码,会得到连续的页码编号,这样不符合我们的要求. 那么如何在word中设置不连续的页码呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJjvep.html" rel="bookmark" class="title">Windows 8怎样在资源管理器快速查看系统属性？</a>
					<div>
						  1.点击资源管理器图标.如下图所示: 2.右键选&quot;计算机&quot;选择属性.如下图所示: 3.此时为计算机系统属性.如下图所示: 4.进阶属性点击&quot;高级系统设置&quot;. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG4Jjb.html" rel="bookmark" class="title">云拼音资讯怎么卸载</a>
					<div>
						  1.开机进入安全模式,在安全模式中任何病毒.木马都无法启动. 2.打开桌面上的&quot;我的电脑&quot;(计算机)进入C盘Program files(64位系统为Program files( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKlJaM.html" rel="bookmark" class="title">Applewatch怎么连接WiFi？</a>
					<div>
						Applewatch怎么连接WiFi?由于苹果没有对外公布 Apple Watch 是怎样连接无线的,所以有很多小伙伴可能都会认为手表并不支持无线.其实手表是有无线功能的,只是苹果并没有开放给我们手动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYkGkM.html" rel="bookmark" class="title">手机百度浏览器怎么换皮肤 手机百度浏览器换皮肤教程</a>
					<div>
						1.我们在手机中打开手机百度浏览器进入后点击下方的[菜单]标志     2.然后在进入之后我们点击向左滑动,打开下一页 细节如下图所示     3.之后在此我们就可以来进行设置[更换壁纸]了,如下图所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWd5Wp.html" rel="bookmark" class="title">Android编程实现禁止系统锁屏与解锁亮屏的方法&lowbar;Android</a>
					<div>
						本文实例讲述了Android编程实现禁止系统锁屏与解锁亮屏的方法.分享给大家供大家参考,具体如下: 需求: 某个时刻任务执行完毕,关闭屏幕,某时刻再开启屏幕继续执行任务 通常情况下,不设置屏幕常亮,系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NZmNM.html" rel="bookmark" class="title">java群号，66305398，欢迎共商大计</a>
					<div>
						问题描述 欢迎有志向的有开发基础的朋友 解决方案 解决方案二:up!!!sf!!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrY5NM.html" rel="bookmark" class="title">用啊D找不到注入点，求大神教学</a>
					<div>
						问题描述 用啊D找不到注入点,求大神教学 地址:http://hebin.xyz/question.php?questionID=1 解决方案 不是打击你 如果你还能用啊d找到注入点 那么这个网站 一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NQKNM.html" rel="bookmark" class="title">window open-firefox下 titlebar加载url的问题</a>
					<div>
						问题描述 firefox下 titlebar加载url的问题 在项目中需要做一个效果就是window.open(urlnameconfig)打开一个窗体,但是浏览器的titlebar中不能显示其地址的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6DXwb.html" rel="bookmark" class="title">Xcode中为何要为设置bundle和App分别设置两份一样的图片资源</a>
					<div>
						大熊猫猪·侯佩原创或翻译作品.欢迎转载,转载请注明出处. 如果觉得写的不好请多提意见,如果觉得不错请多多支持点赞.谢谢! hopy ;) 我们知道在App设置的bundle中有时也会用到图片资源,而在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWxJ6p.html" rel="bookmark" class="title">南通移动：大数据在如东落地生花</a>
					<div>
						近年来,中国移动江苏分公司积极发挥大数据智能作用,不仅让各个领域朝着更加智慧化应用的层面发展,也让产能相对落后的农村地区坐上了快速发展的列车. 大数据推动南通精准扶贫见成效.作为南通地区农村面积最大的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7NBJz.html" rel="bookmark" class="title">世界第一个无人机快递网络下月在瑞士运营 物品 30 分钟内可达</a>
					<div>
						物流公司 Matternet 宣布,将在瑞士建立一个永久的无人机网络,现在将看到实验室样本,如血液测试和其他在医院设施.诊所和实验室之间进行的诊断.第一个交付网络将从下个月开始运营,明年还将推出更多的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6g0Bz.html" rel="bookmark" class="title">关于Scanner和BufferedReader的区别和用法的问题</a>
					<div>
						问题描述 我看了这篇文章,http://blog.csdn.net/moonwalkings/article/details/4632169&lt;Scanner和BufferedReader的区别和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZggl6b.html" rel="bookmark" class="title">android之View绘制</a>
					<div>
						Android系统的视图结构的设计也采用了组合模式,即View作为所有图形的基类,Viewgroup对View继承扩展为视图容器类,由此就得到了视图部分的基本结构--树形结构 View定义了绘图的基本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY5gOp.html" rel="bookmark" class="title">李开复：AI 创业的十个真相 &vert; 深度</a>
					<div>
						&quot;重仓&quot;人工智能,是李开复和创新工场未来几年的方向.但是,他面临一个很重要的问题:现在的 AI 创业,核心是 AI 科学家,而&quot;文能起笔安天下,武能上马定乾坤&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5NmxM.html" rel="bookmark" class="title">Linux上配置Nginx&plus;PHP5&lpar;FastCGI&rpar;</a>
					<div>
						原为地址:http://www.laruence.com/2009/07/28/1030.html Nginx是俄罗斯人编写的十分轻量级的HTTP服务器,以事件驱动的方式编写,所以有非常好的性能,同时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEAE2M.html" rel="bookmark" class="title">ibatis动态语句不同的写法</a>
					<div>
						  所谓的不同写法当然原理一样,只不过我觉得第二种更加清晰和原生一些.   写法一:  &lt;sql id=&quot;queryCondition&quot;&gt;   &lt;dynamic  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5DWEp.html" rel="bookmark" class="title">A11仿生芯片的跑分成绩甚至媲美13英寸MBP</a>
					<div>
						苹果最新发布的 iPhone 8.iPhone 8 Plus 和 iPhone X 配备的是6核 A11芯片,苹果称这款芯片跟 iPhone 7系列使用的 A10 芯片相比实现了一些重大改进,它拥有2 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
